
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux下Power Management开发总结 / 憋错料</title>

    <meta name="description" content="Linux下Power Management开发总结 本文作为一个提纲挈领的介绍性文档,后面会以此展开,逐渐丰富. 关于Linux省电: 保持CPU处于工作状态时: 1. 设备使能RPM,不使用的设备动态关闭. 2. cpufreq动态调节CPU/GPU的频率电压,以达到降低功耗的目的. 3. cpuidle让CPU进入idle状态,或者深睡. 4. cpu hotplug对不使用的CPU进行动态热插拔. CPU进入睡眠状态: 1. suspend,如果整个系统无事可干进入suspend,包括两种suspend idle和suspend to ra">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux下Power Management开发总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><em>本文作为一个提纲挈领的介绍性文档，后面会以此展开，逐渐丰富。</em></p>
<p>关于Linux省电：</p>
<p>保持CPU处于工作状态时：</p>
<p>1. 设备使能RPM，不使用的设备动态关闭。</p>
<p>2. cpufreq动态调节CPU/GPU的频率电压，以达到降低功耗的目的。</p>
<p>3. cpuidle让CPU进入idle状态，或者深睡。</p>
<p>4. cpu hotplug对不使用的CPU进行动态热插拔。</p>
<p>CPU进入睡眠状态：</p>
<p>1. suspend，如果整个系统无事可干进入suspend，包括两种suspend idle和suspend to ram。</p>
<p>2. resume，中断进行唤醒。</p>
<h1>开发流程</h1>
<p>针对一个PM feature进行开发，设计模型是第一步。模型设计好之后，还要保留参数接口，可以基于这些参数针对特殊个体进行优化。</p>
<p>建立一个可以<strong>快速迭代、准确可靠、可量化</strong>的验证环境尤其重要。一方面可以验证设计的模型是否有效、正确；另一方面还可以调整找到最适合的参数。</p>
<p>针对嵌入式设备来说，最主要的是达到性能和功耗的平衡：在满足性能要求的前提下，尽量降低功耗。</p>
<p>这就涉及到如何去量化性能（Performance）和功耗（Power）。</p>
<p>量化功耗比较简单，可以通过Power Monitor在测量点获得数据（测量点的确定很重要！）；</p>
<p>量化性能就比较复杂了，针对不同的功能模块，需要不同的性能分析工具。</p>
<p>另外，针对不同的模块，可能需要产生特定的workload。</p>
<p>最后，可读性强的统计信息或者可视化图表也更有利于得出分析结果。</p>
<p>以LISA为例，可以使用workload rt-app产生特定调度侧率，运行时间，运行在特定CPU上的线程，保证运行环境一致。</p>
<p>通过devlib可以获得测试过程中的Power Monitor数据。</p>
<p>然后通过IPython脚本在浏览器中生成可视化图表和统计信息。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwODM3MDEvMjAxNjEyLzEwODM3MDEtMjAxNjEyMjgxNjMxMzIyMjYtMTk2Mjc4NzE4Ny5wbmc=.jpg"></p>
<p>开发流程</p>
<p>1.设计模型：根据需求在已有框架中设计新的模型（Thermal中的IPA），或者设计一个全新的功耗模型（如EAS）。目前阶段主要是跟踪追随现有功耗模型。</p>
<p>2.内核实现：基于之前功耗模型，在内核中代码实现。</p>
<p>3.验证环境：建立验证模型的环境，一方面要有量化Performance的工具，另一方面还需要量化Power的工具。</p>
<p>4.模型正确与否?：通过验证环境可以查看模型是否符合预期，如果不符合就重新进行设计。</p>
<p>5.调整模型：根据第4步验证结果，重新调整模型缺陷。</p>
<p>6.优化算法：验证算法是否高效，是否更有效的提升Performance，降低Power。</p>
<h1>Android/Linux内核Power Management介绍</h1>
<h2>Thermal Framework</h2>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6388151.html" rel="external nofollow noreferrer">Android/Linux Thermal框架分析及其Governor对比</a>》</p>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6388112.html" rel="external nofollow noreferrer">Android/Linux Thermal Governor之IPA分析与使用</a>》</p>
<h2>cpufreq Framework</h2>
<p>《<a href="http://blog.csdn.net/droidphone/article/details/9346981" rel="external nofollow noreferrer">Linux动态频率调节系统CPUFreq之一：概述</a>》</p>
<p>《<a href="http://blog.csdn.net/droidphone/article/details/9385745" rel="external nofollow noreferrer">Linux动态频率调节系统CPUFreq之二：核心（core）架构与API</a>》</p>
<h2>cpuidle Framework</h2>
<h2>Suspend分析与优化</h2>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6253665.html" rel="external nofollow noreferrer">Suspend to RAM和Suspend to Idle分析，以及在HiKey上性能对比</a>》</p>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6344847.html" rel="external nofollow noreferrer">cpu_ops、suspend_ops、arm_idle_driver以及machine_restart/machine_power_off到底层PSCI Firmware分析</a>》</p>
<h2>WowoTech整理文档</h2>
<p>Linux电源管理(1)_整体架构</p>
<p><a href="http://www.wowotech.net/pm_subsystem/pm_architecture.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/pm_architecture.html</a></p>
<p>Linux电源管理(2)_Generic PM之基本概念和软件架构</p>
<p><a href="http://www.wowotech.net/pm_subsystem/generic_pm_architecture.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/generic_pm_architecture.html</a></p>
<p>Linux电源管理(3)_Generic PM之Reboot过程</p>
<p><a href="http://www.wowotech.net/pm_subsystem/reboot.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/reboot.html</a></p>
<p>Linux电源管理(4)_Power Management Interface</p>
<p><a href="http://www.wowotech.net/pm_subsystem/pm_interface.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/pm_interface.html</a></p>
<p>Linux电源管理(5)_Hibernate和Sleep功能介绍</p>
<p><a href="http://www.wowotech.net/pm_subsystem/std_str_func.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/std_str_func.html</a></p>
<p>Linux电源管理(6)_Generic PM之Suspend功能</p>
<p><a href="http://www.wowotech.net/pm_subsystem/suspend_and_resume.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/suspend_and_resume.html</a></p>
<p>Linux电源管理(7)_Wakeup events framework</p>
<p><a href="http://www.wowotech.net/pm_subsystem/wakeup_events_framework.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/wakeup_events_framework.html</a></p>
<p>Linux电源管理(8)_Wakeup count功能</p>
<p><a href="http://www.wowotech.net/pm_subsystem/wakeup_count.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/wakeup_count.html</a></p>
<p>Linux电源管理(9)_wakelocks</p>
<p><a href="http://www.wowotech.net/pm_subsystem/wakelocks.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/wakelocks.html</a></p>
<p>Linux电源管理(10)_autosleep</p>
<p><a href="http://www.wowotech.net/pm_subsystem/autosleep.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/autosleep.html</a></p>
<p>Linux电源管理(11)_Runtime PM之功能描述</p>
<p><a href="http://www.wowotech.net/pm_subsystem/rpm_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/rpm_overview.html</a></p>
<p>Linux电源管理(12)_Hibernate功能</p>
<p><a href="http://www.wowotech.net/pm_subsystem/hibernation.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/hibernation.html</a></p>
<p>Linux电源管理(13)_Driver的电源管理</p>
<p><a href="http://www.wowotech.net/pm_subsystem/driver_pm.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/driver_pm.html</a></p>
<p>Linux电源管理(14)_从设备驱动的角度看电源管理</p>
<p><a href="http://www.wowotech.net/pm_subsystem/device_driver_pm.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/device_driver_pm.html</a></p>
<p>Linux电源管理(15)_PM OPP Interface</p>
<p><a href="http://www.wowotech.net/pm_subsystem/pm_opp.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/pm_opp.html</a></p>
<p>Linux common clock framework(1)_概述</p>
<p><a href="http://www.wowotech.net/pm_subsystem/clk_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/clk_overview.html</a></p>
<p>Linux common clock framework(2)_clock provider</p>
<p><a href="http://www.wowotech.net/pm_subsystem/clock_provider.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/clock_provider.html</a></p>
<p>Linux common clock framework(3)_实现逻辑分析</p>
<p><a href="http://www.wowotech.net/pm_subsystem/clock_framework_core.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/clock_framework_core.html</a></p>
<p>Linux PM domain framework(1)_概述和使用流程</p>
<p><a href="http://www.wowotech.net/pm_subsystem/pm_domain_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/pm_domain_overview.html</a></p>
<p>Linux cpuidle framework(1)_概述和软件架构</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpuidle_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpuidle_overview.html</a></p>
<p>Linux cpuidle framework(2)_cpuidle core</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpuidle_core.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpuidle_core.html</a></p>
<p>Linux cpuidle framework(3)_ARM64 generic CPU idle driver</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpuidle_arm64.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpuidle_arm64.html</a></p>
<p>Linux cpuidle framework(4)_menu governor</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpuidle_menu_governor.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpuidle_menu_governor.html</a></p>
<p>Linux PM QoS framework(1)_概述和软件架构</p>
<p><a href="http://www.wowotech.net/pm_subsystem/pm_qos_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/pm_qos_overview.html</a></p>
<p>Linux PM QoS framework(2)_PM QoS class</p>
<p><a href="http://www.wowotech.net/pm_subsystem/pm_qos_class.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/pm_qos_class.html</a></p>
<p>Linux PM QoS framework(3)_per-device PM QoS</p>
<p><a href="http://www.wowotech.net/pm_subsystem/per_device_pm_qos.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/per_device_pm_qos.html</a></p>
<p>Linux power supply class(1)_软件架构及API汇整</p>
<p><a href="http://www.wowotech.net/pm_subsystem/psy_class_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/psy_class_overview.html</a></p>
<p>Linux Regulator Framework(1)_概述</p>
<p><a href="http://www.wowotech.net/pm_subsystem/regulator_framework_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/regulator_framework_overview.html</a></p>
<p>Linux Regulator Framework(2)_regulator driver</p>
<p><a href="http://www.wowotech.net/pm_subsystem/regulator_driver.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/regulator_driver.html</a></p>
<p>Linux CPU core的电源管理(1)_概述</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpu_core_pm_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpu_core_pm_overview.html</a></p>
<p>Linux CPU core的电源管理(2)_cpu topology</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpu_topology.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpu_topology.html</a></p>
<p>Linux CPU core的电源管理(3)_cpu ops</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpu_ops.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpu_ops.html</a></p>
<p>Linux CPU core的电源管理(5)_cpu control及cpu hotplug</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpu_hotplug.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpu_hotplug.html</a></p>
<p>linux cpufreq framework(1)_概述</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpufreq_overview.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpufreq_overview.html</a></p>
<p>Linux cpufreq framework(2)_cpufreq driver</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpufreq_driver.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpufreq_driver.html</a></p>
<p>linux cpufreq framework(3)_cpufreq core</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpufreq_core.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpufreq_core.html</a></p>
<p>linux cpufreq framework(4)_cpufreq governor</p>
<p><a href="http://www.wowotech.net/pm_subsystem/cpufreq_governor.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/cpufreq_governor.html</a></p>
<p>linux cpufreq framework(5)_ARM big Little driver</p>
<p><a href="http://www.wowotech.net/pm_subsystem/arm_big_little_driver.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/arm_big_little_driver.html</a></p>
<p>Linux进程冻结技术</p>
<p><a href="http://www.wowotech.net/pm_subsystem/237.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/237.html</a></p>
<p>Common Clock Framework系统结构</p>
<p><a href="http://www.wowotech.net/pm_subsystem/ccf-arch.html" rel="external nofollow noreferrer">http://www.wowotech.net/pm_subsystem/ccf-arch.html</a></p>
<p>Android Power HAL</p>
<h1>开发工具介绍</h1>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6234749.html" rel="external nofollow noreferrer">Workload Automation分析及其使用</a>》</p>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6214879.html" rel="external nofollow noreferrer">LISA介绍及其使用方法</a>》</p>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6235598.html" rel="external nofollow noreferrer">PyVISA介绍</a>》</p>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6235697.html" rel="external nofollow noreferrer">用于科学计算的Python库</a>》</p>
<p>《<a href="http://www.cnblogs.com/arnoldlu/p/6895633.html" rel="external nofollow noreferrer">Linux Power Management Debug</a>》</p>
<p>…</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-15 17:54:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/view/" title="view">view</a>, <a href="https://www.biecuoliao.com/tag/net/" title="net">net</a>, <a href="https://www.biecuoliao.com/tag/one/" title="one">one</a>, <a href="https://www.biecuoliao.com/tag/%e4%bb%a3%e7%a0%81%e5%ae%9e%e7%8e%b0/" title="代码实现">代码实现</a>, <a href="https://www.biecuoliao.com/tag/time/" title="time">time</a>, <a href="https://www.biecuoliao.com/tag/hibernate/" title="hibernate">hibernate</a>, <a href="https://www.biecuoliao.com/tag/%e5%b9%b3%e8%a1%a1/" title="平衡">平衡</a>, <a href="https://www.biecuoliao.com/tag/otp/" title="otp">otp</a>, <a href="https://www.biecuoliao.com/tag/qos/" title="qos">qos</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux下Power Management开发总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OyY7ZM.html" rel="bookmark">Power Management开发的一般模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文作为一个提供挈领的介绍性文档,后面会以此展开,逐渐丰富. 一般开发模型 针对一个PM feature进行开发,设计模型是第一步.模型设计好之后,还要保留参数接口,可以基于这些参数针对特殊个体进行优化. 建立一个可以快速迭代.准确可靠.可量化的验证环境尤其重要.一方面可以验证设计的模型是否有效.正确:另一方面还可以调整找到最适合的参数. 针对嵌入式设备来说,最主要的是达到性能和功耗的平衡:在满足性能要求的前提下,尽量降低功耗. 这就涉及到如何去量化性能(Performance)和功耗(Powe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49ZLWnM.html" rel="bookmark">Linux下spi驱动开发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载至:http://www.embedu.org/Column/Column367.htm 作者:刘洪涛,华清远见嵌入式学院讲师. 一.概述 基于子系统去开发驱动程序已经是linux内核中普遍的做法了.前面写过基于I2C子系 统的驱动开发.本文介绍另外一种常用总线SPI的开发方法.SPI子系统的开发和I2C有很多的相似性,大家可以对比学习.本主题分为两个部分叙述,第一 部分介绍基于SPI子系统开发的理论框架:第二部分以华清远见教学平台FS_S5PC100上的M25P10芯片为例(内核版本2.6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xevEQ3.html" rel="bookmark">linux下配置LAMP开发环境，以及常用小细节</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本来安装没什么可说到.但是在linux当中容易会出现各种各样到问题.我安装以后导致各种问题 比如php无法正常解析,数据库无法关闭,Apache无法开启等等........ 所以搞得我比较郁闷,现在把过程分享下,大家不要在走弯路 最后按照这个顺序来装,避免出问题 [plain] view plaincopy sudo apt-get install mysql-server-5.0 sudo apt-get install apache2 sudo apt-get install php5 li			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEjjGP0.html" rel="bookmark">Linux下搭建Java开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Red Hat Package Manager 简称rpm rpm格式的文件就是我们可以使用RPM命令进行管理的软件包格式的文件 JDK的安装 #sh /root/Desktop/jdk-6u23-linux-i586-rpm.bin .bin 可以使用sh命令来解压执行 Linux的用户的登录过程 /etc/profile /etc/profile.d(各个脚本) /etc/bash.bashrc /home/[username]具体用户目录/.bashrc .bash_profile JDK			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35PxBX0.html" rel="bookmark">Linux下使用Eclipse开发Hadoop应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前面一篇文章中介绍了如果在完全分布式的环境下搭建Hadoop0.20.2,现在就再利用这个环境完成开发. 首先用hadoop这个用户登录linux系统(hadoop用户在前面一篇文章中创建的),然后下载eclipse的tar.gz包到/home/hadoop/这个目录下,直接解压缩,于是就会存在/home/hadoop/eclipse这个目录.在开发之前需要将hadoop0.20.2目录下面的一个jar复制到eclipse下面去.(注:在上一篇文章中我将hadoop0.20.2文件夹修改成了h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vXmqjM.html" rel="bookmark">Linux教程&colon;如何在Linux下进行C&plus;&plus;开发？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux是一类Unix计算机操作系统的统称,Linux操作系统的内核的名字也是“Linux”, 在Linux下进行C++开发,需要注意许多问题,比如:减少不必要的编辑动作,减少编辑的时间. Windows下,开发工具多以集成开发环境IDE的形式展现给最终用户.例如,VS2005集成了编辑器,宏汇编ml,C /C++编译器cl,资源编译器rc,调试器,文档生成工具, nmake.它们以集成方式提供给最终用户,对于初学者而言十分方便. 但是,这种商业模式,直接导致用户可定制性差,不利于自动化,集成			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLQbJO0.html" rel="bookmark">Linux下配置PHP开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载于: http://www.uxtribe.com/php/405.html 该站下有系列PHP文章. 在Linux下搭建PHP环境比Windows下要复杂得多.除了安装Apache,PHP等软件外,还要安装一些相关工具,设置必要参数.而且,如果要使用PHP扩展库,还要进行编译.安装之前要准备如下安装包: http-2.2.8.tar.gz.下载地址:http://www.apache.org. php-5.2.5.tar.gz.下载地址:http://www.php.net/downloa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lqdOE3.html" rel="bookmark">Linux下搭建PHP开发环境（LAMP）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LAMP:Linux+Apache+Mysql/MariaDB+Perl/PHP/Python 安装方法如下: 注:Ubuntu下可使用sudo su 命名切换到root用户. 开始安装之前,先执行EZHTTP安装前的准备工作. 一.使用screen(可选) 由于编译安装Nginx Apache PHP MySQL等软件会花费比较长的时间,难免会出现由于网络意外中断而导致安装也中断了,所以为了避免此问题,可以使用screen来安装. screen的使用方法如下: 1.安装screen ubunt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgPy7n0.html" rel="bookmark">《Python入门》Linux 下 Python Web开发环境搭建笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前写过 Windows 7下Python Web开发环境搭建笔记,今天写一下在Linux系统下搭建Python Web的开发测试环境. 我使用的系统是:ubuntu 14.04 server,根据个人经验,CentOS 6.5 下也适用. 关于Python的版本 进入Python的网站,鼠标移到导航条上的下载,我们会发现提供两下主版本的下载链接! 这两个之间存在什么差别呢? 个人理解,2.7.x的版本为更加稳定的版本,而3.x的版本则是比较前卫的版本,包含了很多新功能新特性之类的: 但如果想要			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZVQG83.html" rel="bookmark" class="title">python学习之 字符串前&amp;&num;39&semi;r&amp;&num;39&semi;的用法</a>
					<div>
						python学习之 字符串前'r'的用法 在打开文件的时候open(r'c:\....') 加r和不加''r是有区别的 'r'是防止字符转义的 如果路径中出现'\t'的话 不加r的话\t就会被转义 而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmzby4.html" rel="bookmark" class="title">DT大数据梦工厂 第71讲</a>
					<div>
						王家林亲授 大数据开发语言&lt;Scala深入浅出实战经典&gt;(1-71讲全部视频.代码.PPT)下载 ,总共有140讲Scala视频!百度云:http://panbaidu.com/s/1jG ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaJnO4.html" rel="bookmark" class="title">获取网络图片&lpar;Bitmap&rpar;至内存或者SD卡</a>
					<div>
						/** * 获取网络图片 * 注意权限: * &lt;uses-permission android:name=&quot;android.permission.INTERNET&quot;/&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5kxeM.html" rel="bookmark" class="title">Mysql 索引原理（转自：张洋）</a>
					<div>
						摘要 本文以MySQL数据库为 研究对象,讨论与数据库索引相关的一些话题.特别需要说明的是,MySQL支持诸多存储引擎,而各种存储引擎对索引的支持也各不相同,因此MySQL数据 库支持多种索引类型,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My56NpM.html" rel="bookmark" class="title">Linux head和tail命令</a>
					<div>
						200 ? &quot;200px&quot; : this.width)!important;} --&gt; 介绍 head和tail是一组想对应的命令,默认分别显示文件的开头和末尾10行记录.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDX1P3.html" rel="bookmark" class="title">理解 Android Build 系统</a>
					<div>
						http://www.ibm.com/developerworks/cn/opensource/os-cn-android-build/ Android Build 系统是用来编译 Android 系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz51GW4.html" rel="bookmark" class="title">poj 3881 区间交判断</a>
					<div>
						水题,直接贴代码. //poj 3881 //sep9 #include &lt;iostream&gt; using namespace std; const int maxN=10024; int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLWQzy4.html" rel="bookmark" class="title">《爱情的名义》  徐正润</a>
					<div>
						对于爱,许多概念我一直很混淆, 比如:因为我爱你所以我牺牲我的事业: 因为我爱你所以我容忍你的好与坏: 因为你爱我所以你不许再爱别的人: 因为你爱我所以你要跟从我…… 我不知道在这些爱的名义下,哪些是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONPjG0.html" rel="bookmark" class="title">sh&lowbar;脚本语法</a>
					<div>
						介绍: 1 开头 程序必须以下面的行开始(必须方在文件的第一行): #!/bin/sh 符号#!用来告诉系统它后面的参数是用来执行该文件的程序.在这个例子中我们使用/bin/sh来执行程序. 当编写脚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONV7r0.html" rel="bookmark" class="title">MVC 5&period;0 之奇葩错误-&amp;lt&semi;类型&OpenCurlyDoubleQuote;ASP&period;&lowbar;Page&lowbar;&lowbar;ViewStart&lowbar;cshtml&rdquo;不从&OpenCurlyDoubleQuote;System&period;Web&period;WebPages&period;StartPage&rdquo;继承&amp;gt&semi;</a>
					<div>
						在实际项目中,我们通常添加MVC项目会先添加一个MVC Empty 的项目,然后需要什么在往里面添加. 但是Empty项目里面只有一个路由注册,而且没有_ViewStart.cshtml文件需要自己添 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWd6m4.html" rel="bookmark" class="title">HDU4841 圆桌问题 【HDU最烂题】</a>
					<div>
						圆桌问题 Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 65535/32768 K (Java/Others) Total Submi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d9Ywz3.html" rel="bookmark" class="title">Facade 模式</a>
					<div>
						在软件系统开发中经常回会遇到这样的情况,你实现了一些接口(模块),而这些接口(模块)都分布在几个类中(比如 A和 B.C.D) :A中实现了一些接口,B 中实现一些接口(或者 A代表一个独立模块,B. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYa9K4.html" rel="bookmark" class="title">Unix Study之--Linux共享访问AIX 6之NFS</a>
					<div>
						Unix Study之--Linux共享访问AIX 6之NFS 1.配置aix 6为nfs server 2.查看nfs server共享 [[email protected] /]# cat /et ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQBoVM.html" rel="bookmark" class="title">JAVA三大框架的各自作用</a>
					<div>
						http://christhb.blog.163.com/blog/static/98982492011727114936239/ 一.Spring Spring是一个解决了许多在J2EE开发中常见的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmYQvDM.html" rel="bookmark" class="title">什么是全角字符</a>
					<div>
						就是太阳和月亮的区别,键盘上有! 你可以用 shift + 空格 键来切换全角和半角 或者用英文输入 简单地讲,全角字符占用2个字符位置,半角字符占用1个字符位置. 他们在应用上的区别主要表现在输入阿 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koJ2d0.html" rel="bookmark" class="title">PPT设计宝典&excl;十招教你做出拿得出手的PPT</a>
					<div>
						据说上班用 excel 的比 word 的工资高,用 ppt 的比用 excel 的工资高.无论如何,在职场演讲汇报中,PPT 扮演着至关重要的角色. 在本文我们将用 10 个超级技巧来解决糟糕的演示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MERaLR0.html" rel="bookmark" class="title">Android Studio 新建项目的R文件丢失的解决方法</a>
					<div>
						最近Android Studio炒的比较热,于是笔者决定赶赶时髦,从Eclipse转到了Android Studio.不幸的是,用Android Studio创建项目的时候就遇到了一个比较尖锐的问题— ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Yq2ma0.html" rel="bookmark" class="title">JAVA编码（中文转码）问题总结</a>
					<div>
						本章主要分析Java编码和解码的原理,以及中文转码存在的问题做个简单的总结 目录 1  编码基础知识 ISO-8859-1编码 GBK GB2312 UTF-8 2  WEB系统转换编码        ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWr2bL4.html" rel="bookmark" class="title">JAVA工具类 UUID</a>
					<div>
						UUID:通用惟一识别:Universally Unique Identifier: 在一台机器上生成的数字,它保证对在同一时空中的所有机器都是唯一的. GUID是一个128位长的数字,一般用16进制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgYOxO3.html" rel="bookmark" class="title">ionic打包配置</a>
					<div>
						最近项目要收尾了,需要将项目的开发与测试分离,需要将打包程序也搬到云服务器上,于是整理相关内容,分享给大家,希望对您能有一定的帮助! 步骤一:安装node.js    去nodejs官网下载nodej ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
